name: build-ecr
on:
  push:
    paths:
      - .github/workflows/build.ecr.yml
      - .github/actions/image-tag/*
      - images/ecr/image_data/**/*
      - images/ecr/test_configs/**/*
      - images/ecr/BUILD
      - WORKSPACE
      - rules/images.bzl
      - images/base/image_data/**/*
      - images/base/test_configs/**/*
      - images/base/BUILD
      - tests/*.yaml

jobs:
  build-and-test:
    runs-on: ubuntu-latest
    steps:
      - uses: actions/checkout@v1

      - name: Build
        run: |
          bazel build //images/ecr:image

      - name: Test
        run: |
          bazel test //images/ecr:test

      - name: Determine tag for image
        id: image
        uses: ./.github/actions/image-tag
        with:
          image: ecr
          repository: $GITHUB_REPOSITORY

      - name: Tag Image
        run: |
          bazel run //images/ecr:image
          docker tag bazel/images/ecr:image ${{ steps.image.outputs.fullname }}
          docker tag bazel/images/ecr:image ${{ steps.image.outputs.image }}:edge

      - name: Push to GitHub Packages
        if: github.ref == 'refs/heads/master'
        run: |
          echo ${{ secrets.GHCR_PAT  }} | docker login ghcr.io --username ${{ github.actor }} --password-stdin
          docker push ${{ steps.image.outputs.fullname}}
